;;;; mother modular generic compiler project
; (c)2001,2002/GPL Oskar Schirmer <oskar@scara.com>
; see file COPYING for GPL license details

; subst.scm: post scanner substituter
; usage:
;   subst substitution-list-file <input-file >output-file
;
; the substitution-list is an association list to substitute
; tokens before output. this is mainly to replace alphanumeric
; terminal symbols scanned as generic words with unique symbol
; names.
;
; the result of scanning are tokens represented as three element
; lists '(symbol "chars-collected-by-put" file-position)


;;; substitute a token
(define subst-file
  (lambda (token)
    (if (list? token)
      (begin
        (write
          (let ((s (assoc (list (car token) (cadr token)) (substitution-list))))
            (if s
              (cons (caadr s) (cons (cadadr s) (cddr token)))
              (let ((s (assoc (list (car token)) (substitution-list))))
                (if s
                  (cons (caadr s) (cdr token))
                  token)))))
        (newline)
        (subst-file (read)))
      (begin
        (write token)
        (newline)))))

(define substitution-list (make-parameter #f))
(load (cadr (argv)))
(subst-file (read))
