;;;; format.scm - Simple string formatting - felix
;
;
; REQUIRES: srfi-23
;
;
; [procedure] (format ARG ...) -> STRING
;
;   Creates a string with ARG ... concatenated together.
;


(define (format . args)
  (apply
   string-append
   (map (lambda (x)
	  (cond ((char? x) (string x))
		((string? x) x)
		((symbol? x) (symbol->string x))
		((number? x) (number->string x))
		((list? x) (apply format x))
		(else (error "can not format" x)) ) )
	args) ) )
